/*  
  Lydkode funktioner i T-SQL 
  Testet p SQL Server 2000 SP3 og SP4
  LydKode() revision 4
*/

create function dbo.IsVowel(@n char)
returns tinyint
as 
begin
   declare @r tinyint
   if (@n in ('A','E','I','O','U','Y','','','','','','')) 
	set @r = 1
   else
	set @r = 0
   return @r
end
go

create function dbo.TalKode(@value varchar(6))
returns integer
as
begin
    declare @a int, @r int, @v int, @f int, @l char
    set @value = rtrim(@value)
    set @a = 1
    set @r = 0
    While @a<=len(@value) and (@a<=6) begin
      set @l = substring(@value,@a,1)
      if @l = 'F'  set @v =  1 else
      if @l = 'G'  set @v =  2 else
      if @l = 'H'  set @v =  3 else
      if @l = 'J'  set @v =  4 else
      if @l = 'K'  set @v =  5 else
      if @l = 'L'  set @v =  6 else
      if @l = 'M'  set @v =  7 else
      if @l = 'N'  set @v =  8 else
      if @l = 'P'  set @v =  9 else
      if @l = 'R'  set @v = 10 else
      if @l = 'S'  set @v = 11 else
      if @l = 'T'  set @v = 12 else
      if @l = 'V'  set @v = 13 else
      if @l = 'X'  set @v = 14 else
      if @l = 'A'  set @v = 15 else
		   set @v =  0
      if @a = 6  set @f = 1 else
      if @a = 5  set @f = 16 else
      if @a = 4  set @f = 256 else
      if @a = 3  set @f = 4096 else
      if @a = 2  set @f = 65536 else
      if @a = 1  set @f = 1048576 else
		 set @f = 0
      set @r = @r | ( @f * @v )
      set @a = @a + 1
    end
    return @r   
end
go


create procedure dbo.LydKode(@str varchar(20), @primary varchar(6) output, @secondary varchar(6) output)
as 
begin
/* 

 --LydKode - Revision 2 - 13:09 07-07-2005
 --LydKode - Revision 3 - 20:54 22-11-2006
 --LydKode - Revision 4 - 23:03 24-05-2010

 --Dansk Fonetisk kodning beregnet til dansk slgtsforskning.
 --Inspiration/ide fra kode til Double MetaPhone (DPM). 
 --DMP er ok, men hndterer ikke dansk prcist nok og har
 --for megen kode for specielle engelske udtryk mv

  --Opdateret til Rev. 3:  
  --HJ/HV undertrykt som udfald, giver nu kun hhv J og V ud
  --ndret fortolkning af AU/OU (tillader Laurs matcher Lars)
  --ndret fortolkning af undertrykt R for match af Lars til Lasse (s Hans ikke matcher Anders)
  --ndret fortolkning, V matcher F kun efter vokal

  --Opdateret til Rev. 4:  
  --ndret fortolkning Y tolkes som I (Nicolay matcher Nicolai)
  --ndret fortolkning C er stumt fr K (Vicki matcher Viki)

*/
  declare @org varchar(20), @l int, @c int, @s varchar(6), @p varchar(6), @prv char, @cur char, @nxt char

-- Korriger evt. patroymer - nu er HANSKONE blevet til HANSSEN
  set @org = upper(@str)

  if right(@org,6)='DATTER' set @org = replace(@org,'DATTER','SEN')
  if right(@org,6)='DOTTIR' set @org = replace(@org,'DOTTIR','SEN')
  if right(@org,4)='KONE'   set @org = replace(@org,'KONE','SEN')
  if right(@org,3)='DTR'    set @org = replace(@org,'DTR','SEN')

-- U/V bruges p skift i bestemte forbindelser (CLAUS og SCHOU)
  set @org = replace(@org,'AV','AU')
  set @org = replace(@org,'OV','OU')

  set @l = len(@org)
  set @c = 1
  set @s = ''
  set @p = ''
  
  if (left(@org,4) = 'SCHM') begin -- SCHMIDT udtales som SMITH, men CH er ellers K
    set @p = @p + 'S'
    set @s = @s + 'S'
    set @c = @c + 3
  end else if (left(@org,1) = 'X') begin
    set @p = @p + 'S'
    set @s = @s + 'S'
    set @c = @c + 1
  end else if (left(@org,2) = 'GN') or 
         (left(@org,2) = 'HV') or 
         (left(@org,2) = 'KN') or 
         (left(@org,2) = 'PS') or 
         (left(@org,2) = 'WR') begin
    set @c = @c + 1
  end else if dbo.IsVowel(left(@org,1))=1 begin
    set @p =  @p + 'A'
    set @s =  @s + 'A'
    if @org='OUE' set @org='OVE'
    set @c = @c + 1
  end
  While (@c <= @l) begin
    if @c-1>0 set @prv = substring(@org,@c-1,1)
    set @cur = substring(@org,@c,1)
    set @nxt = substring(@org,@c+1,1)
    
    if @cur = 'B' begin			-- B matcher altid P
      set @p =  @p + 'P'
      set @s =  @s + 'P'
    end else if @cur = 'C' begin
      if @nxt = 'K' begin
        set @p = @p + ''			--C fr K er stumt (Vicky matcher Viki)
      end else begin
        set @p =  @p + 'K'			--som Claus, Michael 
      end
      if @prv = 'S' and @nxt = 'H' begin 	-- SCHTT matcher SJTT 
        set @s =  @s + 'J'
      end else if (@nxt = 'H') or (@nxt = 'L') begin
	set @s = @s + 'K'
      end else begin
        set @s =  @s + 'S'			-- som Citron
      end
      if (@nxt = 'H') or (@nxt = 'P') set @c = @c + 1
    end else if @cur = 'D'  begin
      if (@prv = 'N') or (@prv = 'L') begin
	    set @p = @p + '' -- D efter N og L kan ikke hres
      end else begin
        set @p =  @p + 'T'
        set @s =  @s + 'T'
	    if @nxt = 'T'  set @c = @c + 1
      end
    end else if @cur = 'F' begin
      set @p =  @p + 'F'
      set @s =  @s + 'F'
    end else if @cur = 'G'  begin
      set @p =  @p + 'G'
      set @s =  @s + 'K'
    end else if @cur = 'H'  begin
      if @nxt <> 'J' and @nxt <> 'V' begin   	-- HJ giver kun J lyd, HV kun V lyd
	     set @p = @p + 'H'
      end 
      If (@c = 1) and (1=dbo.IsVowel(@nxt)) set @s = @s + 'A'	-- Stumt H i start ELLEN matcher HELLEN
    end else if @cur = 'I' or @cur='Y' begin
      if dbo.IsVowel(@prv)=1 begin 		-- Y og I efter vokal kan udtales J
        set @s =  @s + 'J'
      end 
    end else if @cur = 'J' begin
      if (@prv = 'P') or (@prv = 'K') begin
	   set @p = @p + ''  -- J ignores efter P og K - s bliver PJOTR lig PETER og KJELL matcher KELD
      end else begin
       set @p = @p + 'J'
      end
      if (@c = @l) and (dbo.IsVowel(@prv)=1) begin
        set @s=@s+''  -- efter vokal I udtales J - fx NICOLAI - s vi undertrykker J'et
      end else begin
		set @s = @s + 'J'
      end
    end else if @cur = 'K' begin
     set @p =  @p + 'K'
     set @s =  @s + 'K'
    end else if @cur = 'L' begin 
     set @p =  @p + 'L'
     set @s =  @s + 'L'
    end else if @cur = 'M' begin 
     set @p =  @p + 'M'
     set @s =  @s + 'M'
    end else if @cur = 'N' begin 
     set @p =  @p + 'N'
      if @c = 1 and left(@org,3) = 'NIS' begin 	-- NIS = NIELS
	set @s = @s + 'NL'
      end else begin
        set @s =  @s + 'N'
      end
    end else if @cur = 'P' begin
      if @nxt = 'H' begin
        set @p =  @p + 'F'
        set @s =  @s + 'P' 
        set @c = @c + 1
      end else begin
        set @p =  @p + 'P'
        set @s =  @s + 'P'
      end 
    end else if @cur = 'Q' begin
      set @p =  @p + 'K'
      set @s =  @s + 'K'
    end else if @cur = 'R' begin
      set @p =  @p + 'R'
      if (@prv = 'A' and @nxt='S') begin
	     set @s = @s -- Match Lars med Lasse, vi indstter ikke et bogstav
      end else begin
         set @s = @s + 'R'
      end
    end else if @cur = 'S' begin
      set @p =  @p + 'S'
      set @s =  @s + 'S'
      if charindex('SCHL',@org,@c)>0  set @c = @c + 2  --SCHL udtales normalt SL
      if @nxt = 'Z'  set @c = @c + 1 		-- SZ opfattes som SS
    end else if @cur = 'T' begin
      set @p =  @p + 'T'
      set @s =  @s + 'T'
      if @nxt = 'H' set @c = @c + 1
    end else if @cur = 'V' begin
      set @p =  @p + 'V'	
      if (dbo.IsVowel(@prv)=1) -- V udtales enten som V eller F, men kun efter vokal
	set @s = @s + 'F'
      else
	set @s = @s + 'V'
    end else if @cur = 'W' begin
      set @p =  @p + 'V'	-- W udtales som V - men IWERSEN skal ogs matche IFERSEN
      set @s =  @s + 'F'
    end else if @cur = 'X' begin
      set @p =  @p + 'KS'
      set @s =  @s + 'C'
    end else if @cur = 'Z' begin --MATZ svarer til MADS
      set @p =  @p + 'S'
      set @s =  @s + 'S'
      if @nxt = 'S'  set @c = @c + 1
    end   
    set @c = @c + 1
    if @nxt = @cur  set @c = @c + 1
  end
  if @s = @p set @s = ''
  set @primary = @p
  set @secondary = @s
end
go

declare @o1 varchar(5), @o2 varchar(5)
exec dbo.lydkode 'elene',@o1 out,@o2 out
print @o1+' '+@o2
exec dbo.lydkode 'hellen',@o1 out,@o2 out
print @o1+' '+@o2
