option explicit

function IsVowel(n)
  ' Anvendes til at afgre om et tegn er en vokal eller ej.
  IsVowel = (n = "A" or _
      n = "E" or _
      n = "I" or _
      n = "O" or _
      n = "U" or _
      n = "Y" or _ 
      n = "" or _
      n = "" or _
      n = "" or _
      n = "" or _
      n = "" or _
      n = "")
end function

function Talkode(value)
  ' Overstter den fonetiske kode til heltal 
  '  FGHJKLMNPRSTVXA
  ' 0123456789ABCDEF
  dim r, v, l, a, f
  a = 1
  r = 0
  ' Overst vore bogstavkoder til talkoder
  ' Mske grupperes efter lyd for mat. beregning
  ' af afstand ?
  value = trim(value)
  Do while a<=len(value) and a<=6
    l = mid(value,a,1)
    select case l
  	case "F"  v =  1
	case "G"  v =  2	
	case "H"  v =  3
	case "J"  v =  4
	case "K"  v =  5	
	case "L"  v =  6
	case "M"  v =  7
	case "N"  v =  8
	case "P"  v =  9
	case "R"  v = 10
	case "S"  v = 11
	case "T"  v = 12
	case "V"  v = 13
	case "X"  v = 14
	case "A"  v = 15
	case else v =  0
    end select
    ' Der er ikke Shift left/right operatorer i VB, s derfor en workaround
    select case a
       case 6 f = 1		' Factor/hex byte: 00 00 0?
       case 5 f = 16		' Factor/hex byte: 00 00 ?0
       case 4 f = 256		' Factor/hex byte: 00 0? 00
       case 3 f = 4096		' Factor/hex byte: 00 ?0 00
       case 2 f = 65536		' Factor/hex byte: 0? 00 00
       case 1 f = 1048576	' Factor/hex byte: ?0 00 00
       case else f = 0
    end select
    ' Map resultatet ind...
    r = r or (f * v)
    a = a + 1
  loop
  if r = 0 then r = NULL
  Talkode = r
end function
    
sub LydKode(byref str,byref primary, byref secondary)

  ' LydKode - Revision 2 - 13:09 07-07-2005
  ' LydKode - Revision 3 - 20:54 22-11-2006
  ' LydKode - Revision 4 - 23:03 24-05-2010

  ' Dansk Fonetisk kodning beregnet til dansk slgtsforskning.
  ' Inspiration/ide fra kode til Double MetaPhone (DPM). 
  ' DMP er ok, men hndterer ikke dansk prcist nok og har
  ' for megen kode for specielle engelske udtryk mv
  
  ' Opdateret til Rev. 3:  
  '	HJ/HV undertrykt som udfald, giver nu kun hhv J og V ud
  '	ndret fortolkning af AU/OU (tillader Laurs matcher Lars)
  '	ndret fortolkning af undertrykt R for match af Lars til Lasse (s Hans ikke matcher Anders)
  ' 	ndret fortolkning, V matcher F kun efter vokal

  ' Opdateret til Rev. 4:  
  '	ndret fortolkning Y tolkes som I (Nicolay matcher Nicolai)
  '	ndret fortolkning C er stumt fr K (Vicki matcher Viki)

  Dim org, l, c, s, p, prv, cur, nxt

  ' Fjern evt. mellemrum - nu er "HANS' KONE" til "HANS'KONE"
  org = replace(trim(ucase(str))," ","") 

  ' Fjern evt ' for stemt S - nu er HANS'KONE blevet HANSKONE'
  org = replace(org,"'","")

  ' Korriger evt. patroymer - nu er HANSKONE blevet til HANSSEN
  if Right(Org,6)="DATTER" then org = replace(org,"DATTER","SEN")
  if Right(Org,6)="DOTTIR" then org = replace(org,"DOTTIR","SEN")
  if Right(Org,4)="KONE"   then org = replace(org,"KONE","SEN")
  if Right(Org,3)="DTR"    then org = replace(org,"DTR","SEN")

  ' U/V bruges p skift i bestemte forbindelser (CLAUS og SCHOU)
  org = replace(org,"AV","AU")
  org = replace(org,"OV","OU")

  l = len(org)
  c = 1
  s = ""
  p = ""
  
  if (left(org,4) = "SCHM") then  ' SCHMIDT udtales som SMITH, men CH er ellers K
    p = p & "S"
    s = s & "S"
    c = c + 3
  elseif (left(org,1) = "X") then
    p = p & "S"
    s = s & "S"
    c = c + 1
  elseif (left(org,2) = "GN") or _
         (left(org,2) = "HV") or _
         (left(org,2) = "KN") or _
         (left(org,2) = "PS") or _
         (left(org,2) = "WR") then
    c = c + 1
  elseif IsVowel(left(org,1)) then
    p = p & "A"
    s = s & "A"
    if org="OUE" then org="OVE"  ' Hrdt fiks af OU hndteringen delgger navnet OVE.
    c = c + 1
  end if
  Do While c <= l
    if c-1>0 then prv = mid(org,c-1,1)
    cur = mid(org,c,1)
    nxt = mid(org,c+1,1)
    
    if cur = "B" then			' B matcher altid P
      p = p & "P"
      s = s & "P"
    elseif cur = "C" then
      if nxt = "K" then
	p = p & ""			' C fr K er stumt (Vicky matcher Viki)
      else
        p = p & "K"			' som Claus, Michael 
      end if
      if prv = "S" and nxt = "H" then 	' SCHTT matcher SJTT 
        s = s & "J"
      elseif (nxt = "H") or (nxt = "L") then	
	s = s & "K"
      elseif (nxt = "K") then
	s = s & ""			' C fr K er hgstumt
      else
        s = s & "S"			' som Citron
      end if
      if (nxt = "H") or (nxt = "P") then c = c + 1
    elseif cur = "D" then
      if (prv = "N") or (prv = "L") then
	' D efter N og L kan ikke hres
      else
        p = p & "T"
        s = s & "T"
	if nxt = "T" then c = c + 1
      end if
    elseif cur = "F" then
      p = p & "F"
      s = s & "F"
    elseif cur = "G" then
      p = p & "G"
      s = s & "K"
    elseif cur = "H" then
      if (nxt <> "J") and (nxt<>"V") then 	' HJ giver kun J lyd, HV kun V lyd
	p = p & "H"
      end if
      If (c = 1 and IsVowel(Nxt)) then 
	s = s & "A"	' Stumt H i start ELLEN matcher HELLEN
      end if
    elseif cur = "I" or cur ="Y" then	
      if IsVowel(prv) then		' Y og I efter vokal kan udtales J
        s = s & "J"
      end if
    elseif cur = "J" then
      if (prv = "P") or (prv = "K") then	
	' J ignores efter P og K - s bliver PJOTR lig PETER og KJELL matcher KELD
      else
        p = p & "J"
      end if
      if c = l and IsVowel(prv) then	
	' efter vokal I udtales J - fx NICOLAI - s vi undertrykker J'et
      else
	s = s & "J"
      end if
    elseif cur = "K" then
      p = p & "K"
      s = s & "K"
    elseif cur = "L" then	
      p = p & "L"
      s = s & "L"
    elseif cur = "M" then
      p = p & "M"
      s = s & "M"
    elseif cur = "N" then
      p = p & "N"
      if c = 1 and left(org,3) = "NIS" then	' NIS = NIELS
	s = s & "NL"
      else
        s = s & "N"
      end if
    elseif cur = "P" then
      if nxt = "H" then
        p = p & "F"
        s = s & "P" 
        c = c + 1
      else
        p = p & "P"
        s = s & "P"
      end if
    elseif cur = "Q" then
      p = p & "K"
      s = s & "K"
    elseif cur = "R" then
      p = p & "R"
      if (prv = "A") and (nxt="S") then  ' Match Lars med Lasse
'
      else
        s = s & "R"
      end if
    elseif cur = "S" then
      p = p & "S"
      s = s & "S"
      if instr(c,"SCHL",org)>0 then c = c + 2   ' SCHL udtales normalt SL
      if nxt = "Z" then c = c + 1 		' SZ opfattes som SS
    elseif cur = "T" then
      p = p & "T"
      s = s & "T"
      if nxt = "H" then c = c + 1
    elseif cur = "V" then
      p = p & "V"	
      if isVowel(prv) then  ' V udtales enten som V eller F - men kun efter vokal.
	s = s & "F"
      else
	s = s & "V"
      end if
    elseif cur = "W" then
      p = p & "V"	' W udtales som V - men IWERSEN skal ogs matche IFERSEN
      s = s & "F"
    elseif cur = "X" then
      p = p & "KS"
      s = s & "C"
    elseif cur = "Z" then ' MATZ svarer til MADS
      p = p & "S"
      s = s & "S"
      if nxt = "S" then c = c + 1
    end if   
    c = c + 1
    if nxt = cur then c = c + 1
  loop
  if s = p then s = ""
  primary = p
  secondary = s
end sub

' TEST

Dim TestData, A, b, ph1, ph2

TestData = Array("Yrsa", "Udun", "Ydun", "Axel","Aksel",_
	"Appolone","Abbelone","Dorthe","Dorte","Dorothea","Eriksen","Erichsen",_
	"Hellen","Ellen","Elene","Helene","Franz","Frands","Jrchen","Jrgen",_
	"Jollmann","Hjulmand","Iversdatter","Iwersen","Ifersdatter",_
	"Christian","Kresten","Claus","Klaus","Kjell","Keld","Laurits","Lauritz",_
	"Laurids","Laurs","Lasse","Las","Lars","Larsdatter","Laursen","Mickael", "Mikkel","Michael",_
	"Matz","Mads","Madtz","Matzsen","Madsdatter","Madskone","Nicolay","Nikolaj","Nicolai",_
	"Nissen","Nielsen","Nelsen","Ottesen","Otzen","Otzdatter","Palle","Paul",_
	"Povl","Per","Peer","Peter","Peder","Pjotr","Reinhard","Reinharth","Reinert",_
	"Schmidth","Smidt","Schou","Skov","Skaumann","Skovmand","Schoumann","Schovman",_
	"Sjtt","Schtt","Skytte","Thorvald","Torval","Uffe","Uwe","Ove","Wibe","Vibe",_
	"Opheili","Ofelia","Hans","Anders","Vicky", "Vikki", "Viki")

WScript.Echo "PERSONNAVN" & vbTAB & "PRI" & vbTab & "ALT" & vbTAB & "TALVRDI" & vbTAB & "TALVRDI" 
WScript.Echo "----------------------------------------------------------"

A = lBound(TestData)
Do While a<=uBound(testData)
  B = left(TestData(a) & "                  ",15)
  LydKode b, ph1, ph2
  WScript.Echo b & vbTAB & ph1 & vbTAB & ph2 & vbTAB & TalKode(ph1) & "  " & vbTAB & TalKode(ph2)
  a = a + 1
loop
WScript.Echo "----------------------------------------------------------"
WScript.Echo "PERSONNAVN" & vbTAB & "PRI" & vbTab & "ALT" & vbTAB & "TALVRDI" & vbTAB & "TALVRDI" 
